<?php

namespace App\Controller;

use App\Entity\MembreFractal;
use App\Entity\User;
use App\Repository\MembreFractalRepository;
use App\Form\MembreFractalType;
use App\Repository\UserRepository;
use Doctrine\ORM\EntityManagerInterface;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use Symfony\Component\Security\Http\Attribute\IsGranted;

#[Route('/membre')]
#[IsGranted('IS_AUTHENTICATED_FULLY')]
class MembreFractalController extends AbstractController
{
    // Consultation de l'ensemble des membres
    #[IsGranted('ROLE_ADMIN')]
    #[Route('/admin', name: 'app_membre_fractal_index', methods: ['GET'])]
    public function index(MembreFractalRepository $membreFractalRepository): Response
    {
        return $this->render('membre_fractal/index.html.twig', [
            'membre_fractales' => $membreFractalRepository->findAll(),
        ]);
    }
    #[IsGranted('ROLE_USER')]
    #[Route('/edit/{id}', name: 'app_membre_fractal_edit', methods: ['GET','POST'])]
    public function edit(Request $request, MembreFractal $membreFractal, EntityManagerInterface $entityManager): Response
    {
        $form = $this->createForm(MembreFractalType::class, $membreFractal);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $entityManager->flush();

            return $this->redirectToRoute('app_membre_fractal_show', ['id'=>$membreFractal->getId()], Response::HTTP_SEE_OTHER);
        }
        $hasAccess = $this->isGranted('ROLE_ADMIN') ||
            ($this->getUser()==$membreFractal->getUser());
        if(! $hasAccess) {
            throw $this->createAccessDeniedException("Vous ne pouvez pas accéder à un profil qui n'est pas le vôtre.");
        }
        return $this->render('membre_fractal/edit.html.twig', [
            'membre_fractal' => $membreFractal,
            'form' => $form,
        ]);
    }
    //Consultation d'un profil
    #[IsGranted('ROLE_USER')]
    #[Route('/{id}', name: 'app_membre_fractal_show', methods: ['GET'])]
    public function show(MembreFractal $membreFractal): Response
    {
        $hasAccess = $this->isGranted('ROLE_ADMIN') ||
            ($this->getUser()==$membreFractal->getUser());
        if(! $hasAccess) {
            throw $this->createAccessDeniedException("Vous ne pouvez pas accéder à un profil qui n'est pas le vôtre.");
        }
        return $this->render('membre_fractal/show.html.twig', [
            'membre_fractal' => $membreFractal,
        ]);
    }
    #[IsGranted('ROLE_ADMIN')]
    #[Route('/{id}', name: 'app_membre_fractal_delete', methods: ['POST'])]
    public function delete(Request $request, MembreFractal $membreFractal, EntityManagerInterface $entityManager): Response
    {
        if ($this->isCsrfTokenValid('delete'.$membreFractal->getId(), $request->request->get('_token'))) {
            $entityManager->remove($membreFractal);
            $entityManager->flush();
        }

        return $this->redirectToRoute('app_membre_fractal_index', [], Response::HTTP_SEE_OTHER);
    }

}
